# Bosch Sans Font Files

> Nothing more, nothing less

The Bosch brand guide library suggestion is to use only the Bosch Sans Regular (Italic) and Bosch Sans Bold (Italic) font families.

❗️**Deprecated:** Additional weights of the Bosch Sans (Bosch Sans Light, Bosch Sans Medium, Bosch Sans Black) will no longer be further developed in the future.

## Installation steps

You will need to use your [personal access token](https://docs.gitlab.com/ee/user/profile/personal_access_tokens.html#create-a-personal-access-token) with scope `api` for authentication.

```bash
npm config set @cs-bosch-fonts:registry https://src.codespring.ro/api/v4/projects/279/packages/npm/
npm config set -- '//src.codespring.ro/api/v4/projects/279/packages/npm/:_authToken' "<your_personal_access_token>"
```

Then, you can go on to install the dependency:

### yarn

```bash
yarn add @cs-bosch-fonts/bosch-sans-fonts
```

### npm

```bash
npm install @cs-bosch-fonts/bosch-sans-fonts --save
```

### After first install inside the react native application

#### React native >0.69.0

Installation of the font library doesn't link the font files automatically to the iOS or Android project, a few manual steps are necessary: 

1. Create a react-native.config.js file if doesn't exists
2. Extends the config file with `assets` section by adding the Font files from the node_modules. 

```js
module.exports = {
	project: {/*...*/},
	assets: ['./node_modules/@cs-bosch-fonts/bosch-sans-fonts/fonts'],
};
```

3. Run `npx react-native-asset` (the `react-native-asset` doesn't need to add as a project dependency, it can be installed globally)
4. Commit the changes

The `react-native-asset` library creates `link-assets-manifest.json` which helps tracking the linked assets. 

Please see [documentation](https://github.com/callstack/react-native-asset#readme) of the `react-native-asset` library for further details.

## Release

On the `master` branch:

1. Update the `version` field in `package.json`
1. Update `CHANGELOG.md` (if necessary)
1. Commit the changes with the message `"Release <version>"`
1. Tag the commit: `git tag v<version>`
1. Push commit to origin: `git push`
1. Push tag to origin: `git push origin v<version>`

The pipeline will take care of the publishing/releasing.
