"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectionLine = void 0;
const react_1 = __importStar(require("react"));
const react_native_svg_1 = require("react-native-svg");
const metrics_1 = require("./metrics");
const theme_1 = require("../../theme");
const chart_helper_1 = require("./chart-helper");
const SelectionLine = ({ height, xScale, selectedTimestamp, primaryValues, secondaryValues, colors, y1Scale, y2Scale, }) => {
    const { chartTheme } = (0, theme_1.useChartTheme)();
    const selectedPrimaryValues = (0, react_1.useMemo)(() => chart_helper_1.ChartHelper.findValuesByTimestamp(primaryValues, selectedTimestamp), [primaryValues, selectedTimestamp]);
    const selectedSecondaryValues = (0, react_1.useMemo)(() => chart_helper_1.ChartHelper.findValuesByTimestamp(secondaryValues, selectedTimestamp), [secondaryValues, selectedTimestamp]);
    const xPosition = xScale(selectedTimestamp);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_svg_1.Line, { stroke: chartTheme.doubleAxisChart.labelColor, strokeWidth: 1, x: xPosition, y1: 0, y2: height - metrics_1.DOUBLE_AXIS_CHART_METRICS.BOTTOM_PADDING }),
        y1Scale &&
            Object.entries(selectedPrimaryValues).map(([parameter, value]) => value !== undefined && (react_1.default.createElement(react_native_svg_1.Circle, { fill: colors[parameter], key: `${parameter}-selection`, r: metrics_1.DOUBLE_AXIS_CHART_METRICS.SELECTION_DOT_RADIUS, stroke: chartTheme.doubleAxisChart.backgroundColor, strokeWidth: metrics_1.DOUBLE_AXIS_CHART_METRICS.SELECTION_DOT_STROKE, x: xPosition, y: y1Scale(value) }))),
        y2Scale &&
            Object.entries(selectedSecondaryValues).map(([parameter, value]) => value && (react_1.default.createElement(react_native_svg_1.Circle, { fill: colors[parameter], key: `${parameter}-selection`, r: metrics_1.DOUBLE_AXIS_CHART_METRICS.SELECTION_DOT_RADIUS, stroke: chartTheme.doubleAxisChart.backgroundColor, strokeWidth: metrics_1.DOUBLE_AXIS_CHART_METRICS.SELECTION_DOT_STROKE, x: xPosition, y: y2Scale(value) })))));
};
exports.SelectionLine = SelectionLine;
