import { Colors, TestProps } from "@cs-bosch-medusa/ui";
import { FC } from "react";
import { HorizontalStackedBarSection } from "./bar-section";
export type HorizontalStackedBarProps = TestProps & {
    /** A list of the sections that the bar should contain. */
    sections: HorizontalStackedBarSection[];
    /**
     * Color of the section labels/icons.
     * It is applied to the whole bar.
     * If not provided, a theme-based color will be used.
     */
    textColor?: Colors;
    /**
     * Labels and icons will be hidden if their section
     * is narrower than the clipWidth. Defaults to IconSize.XXSMALL.
     */
    clipWidth?: number;
};
export declare const HorizontalStackedBar: FC<HorizontalStackedBarProps>;
//# sourceMappingURL=horizontal-stacked-bar.d.ts.map