"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HorizontalStackedBar = void 0;
const ui_1 = require("@cs-bosch-medusa/ui");
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const bar_section_1 = require("./bar-section");
const horizontal_stacked_bar_metrics_1 = require("./horizontal-stacked-bar-metrics");
const styles = react_native_1.StyleSheet.create({
    container: {
        alignItems: "flex-end",
        flexDirection: "row",
        height: horizontal_stacked_bar_metrics_1.FOCUSED_BAR_HEIGHT,
    },
});
const HorizontalStackedBar = ({ sections, textColor, clipWidth, testID, }) => {
    const { chartTheme } = (0, theme_1.useChartTheme)();
    const mapSectionDataToView = (0, react_1.useCallback)((section, index) => {
        const { flex, backgroundColor, focused, label, icon, id } = section;
        return (react_1.default.createElement(bar_section_1.BarSection, { backgroundColor: backgroundColor, clipWidth: clipWidth !== null && clipWidth !== void 0 ? clipWidth : horizontal_stacked_bar_metrics_1.DEFAULT_CLIP_WIDTH, flex: flex, focused: focused, icon: icon, key: id !== null && id !== void 0 ? id : index, label: label, marginLeft: index === 0 ? 0 : horizontal_stacked_bar_metrics_1.GAP_WIDTH, textColor: textColor !== null && textColor !== void 0 ? textColor : chartTheme.horizontalStackedBar.textColor }));
    }, [chartTheme.horizontalStackedBar.textColor, clipWidth, textColor]);
    return (react_1.default.createElement(react_native_1.View, { style: styles.container, ...(0, ui_1.getTestIdProps)(testID) }, sections.map(mapSectionDataToView)));
};
exports.HorizontalStackedBar = HorizontalStackedBar;
