"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HorizontalTimeLineIndicator = void 0;
const react_1 = __importStar(require("react"));
const react_native_svg_1 = require("react-native-svg");
const horizontal_time_line_metrics_1 = require("./horizontal-time-line-metrics");
const theme_1 = require("../../theme");
/**
 * Horizontal timeline indicator.
 */
const HorizontalTimeLineIndicator = ({ position, height, scale, color }) => {
    const { chartTheme } = (0, theme_1.useChartTheme)();
    const indicatorColor = color !== null && color !== void 0 ? color : chartTheme.horizontalTimeLine.axisColor;
    const scaledPosition = (0, react_1.useMemo)(() => scale(position), [position, scale]);
    return (react_1.default.createElement(react_native_svg_1.G, { fill: indicatorColor, stroke: indicatorColor },
        react_1.default.createElement(react_native_svg_1.Line, { strokeDasharray: horizontal_time_line_metrics_1.HORIZONTAL_TIME_LINE_METRICS.INDICATOR_DASH_ARRAY, x: scaledPosition, y1: 0, y2: height - horizontal_time_line_metrics_1.HORIZONTAL_TIME_LINE_METRICS.BOTTOM_PADDING })));
};
exports.HorizontalTimeLineIndicator = HorizontalTimeLineIndicator;
