"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HorizontalTimeLine = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const horizontal_time_line_metrics_1 = require("./horizontal-time-line-metrics");
const horizontal_time_line_svg_1 = require("./horizontal-time-line-svg");
const styles = react_native_1.StyleSheet.create({
    childrenContainer: {
        paddingBottom: horizontal_time_line_metrics_1.HORIZONTAL_TIME_LINE_METRICS.BOTTOM_PADDING,
        paddingHorizontal: horizontal_time_line_metrics_1.HORIZONTAL_TIME_LINE_METRICS.CONTAINER_PADDING,
    },
    svgContainer: {
        position: "absolute",
    },
});
/**
 * Horizontal Timeline container.
 */
const HorizontalTimeLine = ({ children, timestampRange, currentTimestamp, tickCount, smallTickCount, labelFrequency, indicatorColor, formatLabel, testID, style, containerStyle, }) => {
    const [width, setWidth] = (0, react_1.useState)(0);
    const [height, setHeight] = (0, react_1.useState)(0);
    const onLayout = (0, react_1.useCallback)((event) => {
        setWidth(event.nativeEvent.layout.width);
        setHeight(event.nativeEvent.layout.height);
    }, []);
    return (react_1.default.createElement(react_native_1.View, { style: style },
        react_1.default.createElement(react_native_1.View, { onLayout: onLayout, style: [styles.childrenContainer, containerStyle] }, children),
        react_1.default.createElement(react_native_1.View, { pointerEvents: "none", style: styles.svgContainer },
            react_1.default.createElement(horizontal_time_line_svg_1.HorizontalTimeLineSvg, { currentTimestamp: currentTimestamp, formatLabel: formatLabel, height: height, indicatorColor: indicatorColor, labelFrequency: labelFrequency, smallTickCount: smallTickCount, testID: testID, tickCount: tickCount, timestampRange: timestampRange, width: width }))));
};
exports.HorizontalTimeLine = HorizontalTimeLine;
