"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RealTimeLineChartGrid = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const real_time_line_chart_metrics_1 = require("./real-time-line-chart-metrics");
const theme_1 = require("../../theme");
const DASH_ARRAY = [2, 2];
const RealTimeLineChartGrid = ({ xAxisTickTimestamps, yAxisTickValues, width, height, xScale, yScale, }) => {
    const { chartTheme } = (0, theme_1.useChartTheme)();
    const [firstXAxisTickValue, ...xAxisValues] = xAxisTickTimestamps;
    const [firstYAxisTickValue, ...yAxisValues] = yAxisTickValues;
    return (react_1.default.createElement(react_native_svg_1.G, { fill: chartTheme.realTimeLineChart.axisColor, stroke: chartTheme.realTimeLineChart.axisColor, strokeWidth: chartTheme.realTimeLineChart.axisStrokeWidth },
        react_1.default.createElement(react_native_svg_1.Line, { x1: xScale(firstXAxisTickValue), x2: xScale(firstXAxisTickValue), y1: real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.TOP_PADDING, y2: height - real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.BOTTOM_PADDING }),
        react_1.default.createElement(react_native_svg_1.Line, { x1: real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.LEFT_PADDING, x2: width - real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.RIGHT_PADDING, y1: yScale(firstYAxisTickValue), y2: yScale(firstYAxisTickValue) }),
        react_1.default.createElement(react_native_svg_1.Line, { strokeDasharray: DASH_ARRAY, x1: 0, x2: real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.LEFT_PADDING, y1: yScale(firstYAxisTickValue), y2: yScale(firstYAxisTickValue) }),
        react_1.default.createElement(react_native_svg_1.Line, { strokeDasharray: DASH_ARRAY, x1: width - real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.RIGHT_PADDING, x2: width, y1: yScale(firstYAxisTickValue), y2: yScale(firstYAxisTickValue) }),
        xAxisValues.map((value) => (react_1.default.createElement(react_native_svg_1.Line, { key: `x-axis-grid-line-${value}`, strokeOpacity: chartTheme.realTimeLineChart.gridOpacity, x1: xScale(value), x2: xScale(value), y1: real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.TOP_PADDING, y2: height - real_time_line_chart_metrics_1.REAL_TIME_LINE_CHART_METRICS.BOTTOM_PADDING }))),
        yAxisValues.map((value) => (react_1.default.createElement(react_native_svg_1.Line, { key: `y-axis-grid-line-${value}`, strokeDasharray: DASH_ARRAY, strokeOpacity: chartTheme.realTimeLineChart.gridOpacity, x1: 0, x2: width, y1: yScale(value), y2: yScale(value) })))));
};
exports.RealTimeLineChartGrid = RealTimeLineChartGrid;
