"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RealTimeLineChartLines = void 0;
const react_1 = __importStar(require("react"));
const d3Shape = __importStar(require("d3-shape"));
const react_native_svg_1 = require("react-native-svg");
const utils_1 = require("../../utils");
const RealTimeLineChartLines = ({ values, colors, xScale, yScale, activeParameters, }) => {
    const lineGenerator = (0, react_1.useMemo)(() => d3Shape
        .line()
        .x((data) => xScale(data.timestamp))
        .y((data) => yScale(data.value))
        .defined((data) => (0, utils_1.isNumber)(data.value)), [xScale, yScale]);
    return (
    // eslint-disable-next-line react/jsx-no-useless-fragment
    react_1.default.createElement(react_1.default.Fragment, null, activeParameters.map((parameter) => {
        const parameterValues = values[parameter];
        const path = lineGenerator(parameterValues);
        if (path !== null) {
            return (react_1.default.createElement(react_native_svg_1.Path, { d: path, fill: "none", key: parameter, stroke: colors[parameter] }));
        }
    })));
};
exports.RealTimeLineChartLines = RealTimeLineChartLines;
