import React from "react";
import { CalendarRef } from "./calendar-ref";
import { CalendarPickerDataProps } from "./calendar-picker-data-hook";
export declare const CalendarPickerWeek: React.ForwardRefExoticComponent<Omit<CalendarPickerDataProps, "selectedDay"> & {
    /** The date of the first day in the selected week. */
    weekStart: Date;
    /**
     * Whether to display one continuous select or highlight each day with a separate circle.
     * Defaults to false.
     */
    continuousSelection?: boolean | undefined;
    /**
     * Indicates whether today's date should be marked in the calendar.
     *
     * Defaults to `true`.
     */
    markToday?: boolean | undefined;
    /**
     * Callback to invoke when selected week changes. The date of the
     * first day of the week is passed, regardless of which individual
     * day was pressed.
     *
     * Week start is determined based on the configured locale,
     * e.g. Sunday for en and Monday for de.
     */
    onWeekChange(startDate: Date): void;
} & React.RefAttributes<CalendarRef>>;
//# sourceMappingURL=calendar-picker-week.d.ts.map