import { Colors } from "@cs-bosch-medusa/ui";
export interface ChartTheme {
    /** Real-time line chart related theme configuration. */
    readonly realTimeLineChart: {
        /** Line chart main axis color. */
        readonly axisColor: Colors;
        /** Line chart axis stroke width. */
        readonly axisStrokeWidth: number;
        /** Line chart grid opacity. */
        readonly gridOpacity: number;
        /** Line chart background color. */
        readonly backgroundColor: Colors;
        /** Line chart line width size. */
        readonly lineWidth: number;
    };
    /** Double axis line chart related theme config. */
    readonly doubleAxisChart: {
        /** Line chart main axis color. */
        readonly axisColor: Colors;
        /** Axis label color. */
        readonly labelColor: Colors;
        /** Axis label color when selection is shown. */
        readonly unfocusedLabelColor: Colors;
        /** Line chart background color. */
        readonly backgroundColor: Colors;
        /** Line chart line width size. */
        readonly lineWidth: number;
    };
    /** Tile related theme configuration. */
    readonly tile: {
        /** Tile container color. */
        readonly containerColor: Colors;
        /** Tile background color. */
        readonly backgroundColor: Colors;
        /** Tile label color. */
        readonly labelColor: Colors;
        /** Tile text and border deactivated color. */
        readonly deactivatedColor: Colors;
        /** Tile top line size. */
        readonly topLineSize: number;
        /**
         * Tile label maximum row height limit,
         * if exceeds the limit then ellipsis will be applied.
         */
        readonly maxLabelRowHeightLimit: number;
    };
    readonly horizontalStackedBar: {
        readonly textColor: Colors;
    };
    readonly horizontalTimeLine: {
        /** Timeline axis color. */
        readonly axisColor: Colors;
    };
    /** Theme configuration for ResolutionPicker */
    readonly resolution: {
        /** Text color to use in calendars. */
        readonly textColor: Colors;
        /** Background color of the selection in the calendar. */
        readonly selectedColor: Colors;
        /** Text color inside selection. */
        readonly selectedTextColor: Colors;
    };
}
export declare const boschChartTheme: ChartTheme;
export declare const buderusChartTheme: ChartTheme;
//# sourceMappingURL=chart-themes.d.ts.map