
package com.bosch.tt.rnmedusa.ui;

import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.uimanager.ViewManager;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class RNMedusaUIModule extends ReactContextBaseJavaModule {

	private final ReactApplicationContext reactContext;

	public RNMedusaUIModule(ReactApplicationContext reactContext) {
		super(reactContext);
		this.reactContext = reactContext;
	}

	@Override
	public String getName() {
		return "RNMedusaUI";
	}

	public static class RNMedusaUIPackage implements ReactPackage {
		@Override
		public List<NativeModule> createNativeModules(ReactApplicationContext reactContext) {
			return Arrays.<NativeModule>asList(new RNMedusaUIModule(reactContext));
		}

		// Deprecated from RN 0.47
		public List<Class<? extends JavaScriptModule>> createJSModules() {
			return Collections.emptyList();
		}

		@Override
		public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
			return Collections.emptyList();
		}
	}
}
