"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Screen = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const container_1 = require("./container");
const styles = react_native_1.StyleSheet.create({
    container: {
        flex: 1,
        paddingBottom: theme_1.METRICS.SCREEN.basePadding,
        paddingHorizontal: theme_1.METRICS.SCREEN.basePadding,
    },
    safeArea: {
        flex: 1,
    },
});
/**
 * A screen with the theme's background and base padding applied that occupies the entire display.
 * You should use this or ScrollScreen as the root component of each screen in your app.
 *
 * @see ScrollScreen
 */
const Screen = ({ style, children, testID }) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const containerStyle = react_native_1.StyleSheet.flatten([styles.container, style]);
    const backgroundColor = (_a = react_native_1.StyleSheet.flatten([style]).backgroundColor) !== null && _a !== void 0 ? _a : theme.backgroundColor;
    return (react_1.default.createElement(react_native_1.SafeAreaView, { style: [styles.safeArea, { backgroundColor }] },
        react_1.default.createElement(container_1.Container, { style: containerStyle, testID: testID }, children)));
};
exports.Screen = Screen;
