"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDropdownAnimation = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const icons_1 = require("../icons");
const SHADOW_HEIGHT = 10;
var DropdownOptionsContainerPlacement;
(function (DropdownOptionsContainerPlacement) {
    DropdownOptionsContainerPlacement["BOTTOM"] = "bottom";
    DropdownOptionsContainerPlacement["TOP"] = "top";
})(DropdownOptionsContainerPlacement || (DropdownOptionsContainerPlacement = {}));
const useDropdownAnimation = (optionsHeight) => {
    const [headerLayout, setHeaderLayout] = (0, react_1.useState)({
        x: 0,
        y: 0,
        width: 0,
        height: 0,
    });
    const [isOpen, setIsOpen] = (0, react_1.useState)(false);
    const animatedValue = (0, react_1.useRef)(new react_native_1.Animated.Value(0));
    const dropdownHeaderRef = (0, react_1.useRef)(null);
    const toggle = (0, react_1.useCallback)(() => {
        var _a;
        (_a = dropdownHeaderRef === null || dropdownHeaderRef === void 0 ? void 0 : dropdownHeaderRef.current) === null || _a === void 0 ? void 0 : _a.measureInWindow((x, y, width, height) => {
            setHeaderLayout({ x, y, width, height });
        });
        setIsOpen((wasOpen) => {
            react_native_1.Animated.timing(animatedValue.current, {
                toValue: wasOpen ? 0 : 1,
                duration: theme_1.ANIMATION_DURATION.COLLAPSE,
                useNativeDriver: false,
            }).start();
            return !wasOpen;
        });
    }, []);
    const OpenIcon = (0, react_1.useMemo)(() => 
    // eslint-disable-next-line react/no-unstable-nested-components
    (0, react_1.memo)((iconProps) => (react_1.default.createElement(react_native_1.Animated.View, { style: {
            transform: [
                {
                    scaleY: animatedValue.current.interpolate({
                        inputRange: [0, 1],
                        outputRange: [1, -1],
                    }),
                },
            ],
        } },
        react_1.default.createElement(icons_1.DownIcon, { ...iconProps })))), []);
    const placement = (0, react_1.useMemo)(() => headerLayout.y +
        headerLayout.height +
        optionsHeight +
        SHADOW_HEIGHT >
        react_native_1.Dimensions.get("window").height
        ? DropdownOptionsContainerPlacement.TOP
        : DropdownOptionsContainerPlacement.BOTTOM, [headerLayout.height, headerLayout.y, optionsHeight]);
    const animatedViewStyle = (0, react_1.useMemo)(() => {
        const commonStyle = {
            marginLeft: headerLayout.x - SHADOW_HEIGHT,
            marginRight: react_native_1.Dimensions.get("window").width -
                (headerLayout.x + headerLayout.width + SHADOW_HEIGHT),
            paddingHorizontal: SHADOW_HEIGHT,
        };
        return {
            [DropdownOptionsContainerPlacement.BOTTOM]: {
                ...commonStyle,
                paddingTop: SHADOW_HEIGHT,
                marginTop: headerLayout.y + headerLayout.height - SHADOW_HEIGHT,
                height: animatedValue.current.interpolate({
                    inputRange: [0, 1],
                    outputRange: [0, optionsHeight + SHADOW_HEIGHT * 2],
                }),
            },
            [DropdownOptionsContainerPlacement.TOP]: {
                ...commonStyle,
                paddingBottom: SHADOW_HEIGHT,
                marginTop: animatedValue.current.interpolate({
                    inputRange: [0, 1],
                    outputRange: [
                        headerLayout.y + SHADOW_HEIGHT,
                        headerLayout.y - optionsHeight - SHADOW_HEIGHT,
                    ],
                }),
                height: animatedValue.current.interpolate({
                    inputRange: [0, 1],
                    outputRange: [0, optionsHeight + SHADOW_HEIGHT * 2],
                }),
            },
        };
    }, [
        headerLayout.height,
        headerLayout.width,
        headerLayout.x,
        headerLayout.y,
        optionsHeight,
    ]);
    const justifyContent = placement === DropdownOptionsContainerPlacement.BOTTOM
        ? "flex-start"
        : "flex-end";
    return {
        toggle,
        OpenIcon,
        dropdownHeaderRef,
        animatedViewStyle: animatedViewStyle[placement],
        isOpen,
        justifyContent,
    };
};
exports.useDropdownAnimation = useDropdownAnimation;
