"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TouchableIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const util_1 = require("../../util");
const TouchableIcon = ({ icon: Icon, onPress, disabled, style, fillColor, extraThickness, iconSize, iconSizeInPixels, testID, }) => {
    const { theme } = (0, theme_1.useTheme)();
    return (react_1.default.createElement(react_native_1.TouchableOpacity, { activeOpacity: theme.activeOpacity, disabled: disabled, onPress: onPress, style: style, ...(0, util_1.getTestIdProps)(testID) },
        react_1.default.createElement(Icon, { extraThickness: extraThickness, fillColor: disabled ? theme.disabledColor : fillColor, iconSize: iconSize, iconSizeInPixels: iconSizeInPixels })));
};
exports.TouchableIcon = TouchableIcon;
