"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InfoPopover = void 0;
/* eslint-disable react/jsx-max-depth */
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const icons_1 = require("../icons");
const text_1 = require("../text");
const util_1 = require("../../util");
const styles = react_native_1.StyleSheet.create({
    container: {
        borderWidth: 1,
        maxHeight: "80%",
        padding: theme_1.METRICS.CONTAINER.basePadding,
    },
    modal: {
        justifyContent: "center",
    },
    titleBar: {
        alignItems: "center",
        flexDirection: "row",
        marginBottom: theme_1.METRICS.CONTAINER.baseMargin,
    },
    titleLabel: {
        flex: 1,
    },
});
/**
 * Info icon that when clicked, shows a popover information modal
 * that renders the children passed to this component.
 */
const InfoPopover = ({ title, iconSize, iconSizeInPixels, children, testID, }) => {
    const { theme } = (0, theme_1.useTheme)();
    const [visible, setVisible] = (0, react_1.useState)(false);
    const onIconPress = (0, react_1.useCallback)(() => setVisible(true), []);
    const onClosePress = (0, react_1.useCallback)(() => setVisible(false), []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.TouchableOpacity, { activeOpacity: theme.activeOpacity, onPress: onIconPress, ...(0, util_1.getTestIdProps)(`${testID}.open`) },
            react_1.default.createElement(icons_1.InfoIcon, { fillColor: theme.primaryColor, iconSize: iconSize, iconSizeInPixels: iconSizeInPixels })),
        react_1.default.createElement(react_native_1.Modal, { onRequestClose: onClosePress, transparent: true, visible: visible, ...(0, util_1.getTestIdProps)(`${testID}.modal`) },
            react_1.default.createElement(react_native_1.View, { style: [
                    theme_1.MODAL_STYLES.modalView,
                    styles.modal,
                    { backgroundColor: theme.modalBackgroundColor },
                ] },
                react_1.default.createElement(react_native_1.View, { style: [
                        styles.container,
                        {
                            backgroundColor: theme.backgroundColor,
                            borderColor: theme.separatorColor,
                        },
                    ], ...(0, util_1.getTestIdProps)(testID) },
                    react_1.default.createElement(react_native_1.View, { style: styles.titleBar },
                        react_1.default.createElement(react_native_1.View, { style: styles.titleLabel },
                            react_1.default.createElement(text_1.Label, null, title)),
                        react_1.default.createElement(react_native_1.TouchableOpacity, { activeOpacity: theme.activeOpacity, onPress: onClosePress, ...(0, util_1.getTestIdProps)(`${testID}.close`) },
                            react_1.default.createElement(icons_1.CloseIcon, { iconSize: icons_1.IconSize.XSMALL }))),
                    children)))));
};
exports.InfoPopover = InfoPopover;
