import React from "react";
import { StyleProp, ViewStyle } from "react-native";
import { CommonValidationProps } from "./text-field-validation-info";
import { InputFieldProps, TextFieldPointerEvents } from "./input-field";
import { TextFieldRef } from "./text-field-ref";
export type CustomizableTextFieldProps = InputFieldProps & CommonValidationProps & {
    /** Styling to apply to the text field container. */
    containerStyle?: StyleProp<ViewStyle>;
    /**
     * Whether the contents of the text fields can be changed.
     * Defaults to `true`.
     */
    editable?: boolean;
    /** Controls whether the component can be the target of touch events. */
    pointerEvents?: TextFieldPointerEvents;
};
export declare const CustomizableTextField: React.ForwardRefExoticComponent<import("../../util").TestProps & {
    style?: StyleProp<import("react-native").TextStyle>;
    value?: string | undefined;
    disabled?: boolean | undefined;
    maxLength?: number | undefined;
    type?: ("text" | "password") | undefined;
    placeholder?: string | undefined;
    placeholderColor?: import("../..").Colors | undefined;
    autoCapitalize?: ("none" | "sentences" | "words") | undefined;
    keyboardType?: ("default" | "number-pad" | "decimal-pad" | "numeric" | "email-address" | "phone-pad") | undefined;
    textAlign?: ("center" | "left" | "right") | undefined;
    onValueChange: (value: string) => void;
    onFocus?: (() => void) | undefined;
    onBlur?: (() => void) | undefined;
} & CommonValidationProps & {
    /** Styling to apply to the text field container. */
    containerStyle?: StyleProp<ViewStyle>;
    /**
     * Whether the contents of the text fields can be changed.
     * Defaults to `true`.
     */
    editable?: boolean | undefined;
    /** Controls whether the component can be the target of touch events. */
    pointerEvents?: TextFieldPointerEvents | undefined;
} & React.RefAttributes<TextFieldRef>>;
//# sourceMappingURL=customizable-text-field.d.ts.map