"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEyeButton = void 0;
const react_1 = __importDefault(require("react"));
const icons_1 = require("../icons");
const useEyeButton = (buttonShown) => {
    const [isSecretVisible, setIsSecretVisible] = react_1.default.useState(false);
    const onEyeIconPress = react_1.default.useCallback(() => {
        setIsSecretVisible((prevSecretVisible) => !prevSecretVisible);
    }, []);
    const EyeIcon = react_1.default.useMemo(() => {
        if (!buttonShown) {
            // eslint-disable-next-line unicorn/no-null
            return null;
        }
        return isSecretVisible ? icons_1.WatchOffBoldIcon : icons_1.WatchOnIcon;
    }, [buttonShown, isSecretVisible]);
    return { isSecretVisible, EyeIcon, onEyeIconPress };
};
exports.useEyeButton = useEyeButton;
