"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollapsibleListItem = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const list_item_1 = require("./list-item");
const separators_1 = require("../separators");
const collapsible_component_1 = require("../collapsible-component");
const icons_1 = require("../icons");
const styles = react_native_1.StyleSheet.create({
    children: {
        paddingHorizontal: theme_1.METRICS.SCREEN.basePadding,
        paddingVertical: theme_1.METRICS.CONTAINER.basePadding,
    },
});
/**
 * Items that make up a list which are collapsible.
 *
 * Acts and behaves as a ListItem with the exception that the `rightComponent` and `onPress`
 * properties are not accessible.
 *
 * Children must be given, otherwise use `ListItem` instead.
 */
const CollapsibleListItem = ({ children, testID, ...restProps }) => {
    const { theme } = (0, theme_1.useTheme)();
    return (react_1.default.createElement(collapsible_component_1.CollapsibleComponent, { render: (0, react_1.useCallback)((CollapsibleContent, CollapseIcon, toggle) => (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(list_item_1.ListItem
            // eslint-disable-next-line react/jsx-props-no-spreading
            , { ...restProps, onPress: toggle, rightComponent: react_1.default.createElement(CollapseIcon, { iconSize: icons_1.IconSize.XSMALL, pressable: false }), testID: testID }),
            react_1.default.createElement(CollapsibleContent, null,
                react_1.default.createElement(react_native_1.View, { style: styles.children }, children),
                react_1.default.createElement(separators_1.Separator, { style: {
                        backgroundColor: theme.list.default.lineColor,
                    } })))), [children, restProps, testID, theme.list.default.lineColor]), testID: testID }));
};
exports.CollapsibleListItem = CollapsibleListItem;
