"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoadingModal = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const loading_indicator_1 = require("./loading-indicator");
const util_1 = require("../../util");
const doNothing = () => {
    /* Empty */
};
const styles = react_native_1.StyleSheet.create({
    container: {
        flex: 0.8,
        justifyContent: "center",
    },
    content: {
        alignItems: "center",
        flex: 0.3,
        justifyContent: "center",
    },
});
const LoadingModal = ({ visible, children, testID, }) => {
    const { theme } = (0, theme_1.useTheme)();
    return (react_1.default.createElement(react_native_1.Modal, { onRequestClose: doNothing, transparent: true, visible: visible },
        react_1.default.createElement(react_native_1.View, { style: [
                theme_1.MODAL_STYLES.modalView,
                { backgroundColor: theme.modalBackgroundColor },
            ], ...(0, util_1.getTestIdProps)(testID) },
            react_1.default.createElement(react_native_1.View, { style: styles.container },
                react_1.default.createElement(react_native_1.View, { style: styles.content },
                    react_1.default.createElement(loading_indicator_1.LoadingIndicator, null),
                    children)))));
};
exports.LoadingModal = LoadingModal;
