"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndeterminateProgressBar = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const progress_bar_wrapper_1 = require("./progress-bar-wrapper");
const ANIMATION_SPEED_MILLISECONDS = 2000;
const AnimatedView = react_native_1.Animated.createAnimatedComponent(react_native_1.View);
const styles = react_native_1.StyleSheet.create({
    progressBarSquare: {
        height: "100%",
        width: "10%",
    },
});
const IndeterminateProgressBar = ({ testID }) => {
    const { theme } = (0, theme_1.useTheme)();
    const leftMargin = (0, react_1.useRef)(new react_native_1.Animated.Value(0));
    (0, react_1.useEffect)(() => {
        react_native_1.Animated.loop(react_native_1.Animated.timing(leftMargin.current, {
            toValue: 1,
            duration: ANIMATION_SPEED_MILLISECONDS,
            easing: react_native_1.Easing.linear,
            useNativeDriver: false,
        })).start();
    }, []);
    return (react_1.default.createElement(progress_bar_wrapper_1.ProgressBarWrapper, { testID: testID },
        react_1.default.createElement(AnimatedView, { style: [
                styles.progressBarSquare,
                {
                    marginLeft: leftMargin.current.interpolate({
                        inputRange: [0, 1],
                        outputRange: ["0%", "90%"],
                    }),
                    backgroundColor: theme.primaryColor,
                },
            ] })));
};
exports.IndeterminateProgressBar = IndeterminateProgressBar;
