"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadioButtonContainer = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const util_1 = require("../../util");
const isRadioButton = (child) => {
    return typeof child === "object" && "props" in (child !== null && child !== void 0 ? child : {});
};
/**
 * A component that lets the user select an option from the list of possible
 * values.
 */
const RadioButtonContainer = (props) => {
    const { value, children, disabled = false, onChange, testID } = props;
    return (react_1.default.createElement(react_native_1.View, null, react_1.default.Children.toArray(children)
        .filter(isRadioButton)
        .map((button) => (react_1.default.createElement(RadioButtonWrapper, { button: button, currentValue: value, disabled: disabled, key: `${button.props.value}`, onChange: onChange, testID: `${testID}.${button.props.value}` })))));
};
exports.RadioButtonContainer = RadioButtonContainer;
const RadioButtonWrapper = (props) => {
    const { button, currentValue, disabled, onChange, testID } = props;
    const { value: buttonValue } = button.props;
    const selected = currentValue === buttonValue;
    const onButtonPress = (0, react_1.useCallback)(() => onChange(buttonValue), [buttonValue, onChange]);
    return (react_1.default.createElement(react_native_1.Pressable, { disabled: disabled, onPress: onButtonPress, ...(0, util_1.getTestIdProps)(testID) }, ({ pressed }) => react_1.default.cloneElement(button, {
        selected,
        pressed,
        disabled,
    })));
};
