"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Supergraphic = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const react_native_svg_1 = require("react-native-svg");
const supergraphic_inner_svg_1 = require("./supergraphic-inner-svg");
const viewBoxWidth = 826.8;
const viewBoxHeight = 30;
const styles = react_native_1.StyleSheet.create({
    overflow: {
        overflow: "hidden",
    },
});
/**
 * Colored supergraphic svg for Bosch design.
 */
const Supergraphic = ({ height }) => {
    return (react_1.default.createElement(react_native_1.View, { style: [styles.overflow, { height }] },
        react_1.default.createElement(react_native_svg_1.Svg, { height: "100%", preserveAspectRatio: "none", viewBox: `353 -6 ${viewBoxWidth} ${viewBoxHeight}`, width: "100%" },
            react_1.default.createElement(react_native_svg_1.Defs, null,
                react_1.default.createElement(react_native_svg_1.Path, { d: "M353-6h827.5v30H353z", id: "supergraphic_svg__SVGID_1_" })),
            react_1.default.createElement(react_native_svg_1.ClipPath, { id: "supergraphic_svg__SVGID_2_" },
                react_1.default.createElement(react_native_svg_1.Use, { xlinkHref: "#supergraphic_svg__SVGID_1_" })),
            react_1.default.createElement(react_native_svg_1.G, { clipPath: "url(#supergraphic_svg__SVGID_2_)" },
                react_1.default.createElement(supergraphic_inner_svg_1.SupergraphicInnerSvg, null)))));
};
exports.Supergraphic = Supergraphic;
