"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScrollableNewSection = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const theme_1 = require("../../theme");
const text_1 = require("../text");
const styles = react_native_1.StyleSheet.create({
    center: {
        textAlign: "center",
    },
    scrollContainer: {
        flexShrink: 1,
    },
    sectionTitle: {
        paddingBottom: theme_1.METRICS.CONTAINER.halfBasePadding,
        paddingTop: theme_1.METRICS.CONTAINER.doubleBasePadding,
        textAlign: "center",
    },
});
const ScrollableNewSection = ({ newsSections }) => {
    const { theme } = (0, theme_1.useTheme)();
    return (react_1.default.createElement(react_native_1.View, { style: styles.scrollContainer },
        react_1.default.createElement(react_native_1.ScrollView, null, newsSections.map((section, i) => (
        // eslint-disable-next-line react/no-array-index-key
        react_1.default.createElement(react_1.default.Fragment, { key: `${section.title}-${i}` },
            react_1.default.createElement(text_1.Label, { style: [
                    styles.sectionTitle,
                    {
                        fontFamily: theme.boldFont,
                        color: theme.whatsNew.textColor,
                    },
                ] }, section.title),
            react_1.default.createElement(text_1.Label, { style: [
                    styles.center,
                    {
                        color: theme.whatsNew.textColor,
                    },
                ] }, section.content)))))));
};
exports.ScrollableNewSection = ScrollableNewSection;
