import { FC } from "react";
import { TestProps } from "../../util";
export type NewsSection = {
    title: string;
    content: string;
};
export type WhatsNewModalProps = {
    /** Whether to show the modal. */
    visible: boolean;
    /**
     * Callback called when modal is closed.
     * Use this to set `visibility` to `false` on the caller side.
     */
    onClose(): void;
    /** The title at the top of the modal. */
    title: string;
    /** The title and text describing each novelty. */
    newsSections: NewsSection[];
    /** The label of the button at the bottom. */
    buttonText: string;
} & TestProps;
export declare const WhatsNewModal: FC<WhatsNewModalProps>;
//# sourceMappingURL=whats-new.d.ts.map