"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatteryFailIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const BatteryFailIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M88.978 119.022c0 2.722-2.256 4.978-4.978 4.978-2.8 0-4.978-2.178-4.978-4.978s2.178-4.978 4.978-4.978c2.722 0 4.978 2.256 4.978 4.978zm-8.555-33.6V68h7.155v17.422l-1.867 21.467h-3.422l-1.866-21.467zM176 72h-24V52H16v88h136v-20h24V72zm-32 60H24V60h120v72zm24-20h-16V80h16v32z" }))));
};
exports.BatteryFailIcon = BatteryFailIcon;
