"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BedDoubleIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const BedDoubleIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M176 104c0-7.4-5.1-13.7-12-15.5V56c0-6.6-5.4-12-12-12H40c-6.6 0-12 5.4-12 12v32.5c-6.9 1.8-12 8-12 15.5v28h12v12h8v-12h120v12h8v-12h12v-28zM40 52h112c2.2 0 4 1.8 4 4v32h-8c0-8.8-7.2-16-16-16h-16c-8.8 0-16 7.2-16 16h-8c0-8.8-7.2-16-16-16H60c-8.8 0-16 7.2-16 16h-8V56c0-2.2 1.8-4 4-4zm100 36h-32c0-4.4 3.6-8 8-8h16c4.4 0 8 3.6 8 8zm-56 0H52c0-4.4 3.6-8 8-8h16c4.4 0 8 3.6 8 8zm84 36H24v-20c0-4.4 3.6-8 8-8h128c4.4 0 8 3.6 8 8v20z" }))));
};
exports.BedDoubleIcon = BedDoubleIcon;
