"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BookInfoIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const BookInfoIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M108 32c-4.78 0-9.066 2.118-12 5.453C93.066 34.118 88.78 32 84 32H16v120h68c4.411 0 8 3.589 8 8h8c0-4.411 3.589-8 8-8h68V32h-68zM92 146.147A15.901 15.901 0 0084 144H24V40h60c4.411 0 8 3.589 8 8v98.147zM168 144h-60c-2.912 0-5.646.782-8 2.147V48c0-4.411 3.589-8 8-8h60v104zm-36-68h8v52h-8V76zm-2-14c0-3.273 2.727-6 6-6s6 2.727 6 6-2.727 6-6 6-6-2.727-6-6z" }))));
};
exports.BookInfoIcon = BookInfoIcon;
