"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooksIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const BooksIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M64 72h-8v-8h8v8zm0 8h-8v8h8v-8zm0 16h-8v8h8v-8zm48-12h-8v8h8v-8zm0 20h-8v8h8v-8zm41.404 57.026L128 81.364V160H16V32h32v16h24V36h24v28h26.463l-6.733-21.112 22.866-7.292 37.674 118.138-22.866 7.292zM96 72v64h24V72H96zM80 48v88h8V44h-8v4zm-40 8H24v80h16V56zM24 40v8h16v-8H24zm16 112v-8H24v8h16zm32-96H48v96h24V56zm16 96v-8h-8v8h8zm32 0v-8H96v8h24zm46.217-3.457l-2.43-7.622-7.622 2.431 2.43 7.622 7.622-2.431zm-4.86-15.244l-23.092-72.406-7.621 2.43 23.09 72.407 7.622-2.43zm-35.574-85.22l2.43 7.622 7.622-2.43-2.43-7.622-7.622 2.43z" }))));
};
exports.BooksIcon = BooksIcon;
