"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BuildingIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const BuildingIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M116.5 31.8L32 52.9V160h128V53.5l-43.5-21.7zM120 152v-32h16v32h-16zm32 0h-8v-40h-32v40H40V59.1l75.5-18.9L152 58.5V152z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M48 100h56V68H48v32zm8-24h40v16H56V76zm56 24h32V68h-32v32zm8-24h16v16h-16V76zm-72 68h56v-32H48v32zm8-24h40v16H56v-16z" }))));
};
exports.BuildingIcon = BuildingIcon;
