"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarClockIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const CalendarClockIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M136 32V20h-8v12H64V20h-8v12H16v128h91.3c-1.1-2.5-2-5.2-2.5-8H24V72h144v40c3 2.3 5.7 5 8 8V32h-40zM24 64V40h32v7h8v-7h64v7h8v-7h32v24H24z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M144 176c-17.6 0-32-14.4-32-32s14.4-32 32-32 32 14.4 32 32-14.4 32-32 32zm0-56c-13.2 0-24 10.8-24 24s10.8 24 24 24 24-10.8 24-24-10.8-24-24-24z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M156 148h-16v-20h8v12h8z" }))));
};
exports.CalendarClockIcon = CalendarClockIcon;
