"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClipboardUpdateIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const ClipboardUpdateIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M168 112.3v10.4c-6-6.7-14.7-10.7-24-10.7-17.6 0-32 14.2-32 31.6h8c0-13 10.8-23.6 24-23.6 7 0 13.5 3 18 8h-9.7v8H176v-23.7h-8zm0 32.2c0 13-10.7 23.5-23.8 23.5-6.9 0-13.4-3-17.9-8h8.7v-8h-23v23h8v-10c6 6.9 14.8 11 24.2 11 17.5 0 31.8-14.1 31.8-31.5h-8z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M48 168V32h20v8h56v-8h20v72h8V24h-28v-8H68v8H40v152h64v-8H48zM76 24h40v8H76v-8z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M128 104v-8H64v8h40zM64 68h64v8H64zm0 56h28v8H64z" }))));
};
exports.ClipboardUpdateIcon = ClipboardUpdateIcon;
