"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeleteIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const DeleteIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M152 56H40V40h112v16zm-12 104c0 4.4-3.6 8-8 8H60c-4.4 0-8-3.6-8-8V64h16v56h8V64h16v56h8V64h16v56h8V64h16v96zM80 24h32c4.4 0 8 3.6 8 8H72c0-4.4 3.6-8 8-8m80 8h-32c0-8.8-7.2-16-16-16H80c-8.8 0-16 7.2-16 16H32v32h12v96c0 8.8 7.2 16 16 16h72c8.8 0 16-7.2 16-16V64h12V32z" }))));
};
exports.DeleteIcon = DeleteIcon;
