"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DongleConnectedIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const DongleConnectedIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M58.828 49.172a4 4 0 11-5.657 5.656 4 4 0 015.657-5.656zm16.97-16.97l5.658-5.658c-14.037-14.036-36.875-14.036-50.912 0L36.2 32.2c10.917-10.918 28.68-10.918 39.598 0zm-5.656 5.656C66.365 34.081 61.342 32 56 32s-10.365 2.08-14.142 5.858l5.657 5.657C49.781 41.249 52.795 40 56 40s6.219 1.249 8.485 3.515l5.657-5.657zM160 59.546V140c0 7.402-4.598 12-12 12h-8l-.002 16.119c.002 2.563-1.14 4.795-3.216 6.28-1.4 1.003-3.187 1.601-4.782 1.601H60c-3.888 0-8-4.112-8-8v-16h-8c-7.738 0-12-4.262-12-12V40l8 8v92c0 3.252.748 4 4 4h104c2.953 0 4-1.047 4-4V59.546C152 48.951 142.875 40 132.074 40H80.627L88 32h44.074C147.472 32 160 44.357 160 59.546zM132 152H60v15.571c.11.147.282.318.429.429h71.46a.893.893 0 00.108-.038L132 152z" }))));
};
exports.DongleConnectedIcon = DongleConnectedIcon;
