"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const EditIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M16 148h40v8H16zM170.8 47.7c-8.2-8.2-21.5-8.2-29.7 0l-68.8 68.8-9.8 39.5 39.5-9.9 66-66 2.8-2.8c8.2-8.1 8.2-21.5 0-29.6zm-89.1 70.8L136 64.1l18.3 18.4-54.3 54.3-18.3-18.3zm-3.5 7.8l14 14-18.7 4.7 4.7-18.7zM165.8 71l-5.8 5.8-18.3-18.4 5.7-5.7c5.1-4.5 12.9-4.3 17.7.6 5 4.9 5.2 12.6.7 17.7z" }))));
};
exports.EditIcon = EditIcon;
