"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericDeviceConnectedIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const GenericDeviceConnectedIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M58.828 49.172a4 4 0 11-5.656 5.656 4 4 0 015.656-5.656zm22.628-22.628c-14.037-14.036-36.875-14.036-50.912 0L36.2 32.2c10.917-10.918 28.68-10.918 39.598 0l5.657-5.657zM70.142 37.858C66.365 34.081 61.342 32 56 32s-10.365 2.08-14.142 5.858l5.657 5.657C49.781 41.249 52.795 40 56 40s6.219 1.249 8.485 3.515l5.657-5.657zM160 148V59.546C160 44.357 147.472 32 132.074 32H88v8h44.074C142.875 40 152 48.951 152 59.546V148c0 2.953-1.047 4-4 4H44c-3.252 0-4-.748-4-4V48h-8v100c0 7.738 4.262 12 12 12h104c7.402 0 12-4.598 12-12z" }))));
};
exports.GenericDeviceConnectedIcon = GenericDeviceConnectedIcon;
