"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GridBatteryIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const GridBatteryIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 24 24", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { fill: "none", d: "M0 24h24V0H0z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M10.1 22.1l-1-.2 4.3-20 .9.2zM19.5 5V2h-4.1l-.2 1h3.3v2h-3.8l-.2 1H21v15h-9v-3.1l-.1.4v.2l-.2 1-.4 1.5-.2 1H22V5zM11 7.5v.7l.1-.7z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M7.6 4l.2-1H9l.2 1zm-1 6.4l1 .6-1.3.8zm.3-1.9h3.2l.2.9-1.7 1.1-1.8-1.1zm.9 8.5L5 18.6l.6-3.1zm3.6-12l-.9-.8L9.9 2H7.1l-.5 2.2-3.6 3v1.3h2.9L3.6 21H2v1h6.1l.2-1H4.6l.2-1.1 3.9-2.3.3.1.3-1.7-.6.4-2.9-1.9.2-1.2 2.5-1.6 1.5 1 .2-1-.8-.5 1-.6v.2l.6-2.6v-.7H4.2l3-2.5h2.6L11 6v1.5h.1l.3-1.2.2-1.1V5zM13 17.5V20h7v-2.5zm0-1h7V14h-7zm7-3.5v-2.5h-6.4L13 13zm-6-4.5l-.2 1H20V7h-5.7zm0 0" }))));
};
exports.GridBatteryIcon = GridBatteryIcon;
