"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaptopIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const LaptopIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M164 118.7V48c0-6.6-5.4-12-12-12H40c-6.6 0-12 5.4-12 12v70.7l-12 16v9.3c0 6.6 5.4 12 12 12h136c6.6 0 12-5.4 12-12v-9.3l-12-16zM40 44h112c2.2 0 4 1.8 4 4v68H36V48c0-2.2 1.8-4 4-4zm-6 80h124l6 8H28l6-8zm130 24H28c-2.2 0-4-1.8-4-4v-4h144v4c0 2.2-1.8 4-4 4z" }))));
};
exports.LaptopIcon = LaptopIcon;
