"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LeafSimpleIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const LeafSimpleIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M159.932 35.263l-.505-2.69-2.69-.505c-.674-.126-16.747-3.078-37.529-1.557-27.793 2.033-50.628 11.253-66.037 26.66-14.15 14.152-18.658 32.776-13.036 53.86 2.969 11.133 7.988 20.092 10.724 24.453L29.17 157.171l5.658 5.658 21.687-21.688c4.361 2.736 13.32 7.755 24.453 10.724 5.892 1.571 11.589 2.35 17.052 2.35 14.089 0 26.61-5.19 36.808-15.386 15.407-15.409 24.627-38.244 26.66-66.037 1.52-20.78-1.43-36.855-1.557-37.53zm-30.76 97.908c-12.14 12.14-27.592 15.847-45.924 11.022-8.992-2.367-16.548-6.302-20.903-8.881l60.484-60.483-5.658-5.658-60.48 60.481c-6.532-11.075-21.76-42.926 2.138-66.823 29.924-29.925 81.238-25.026 93.667-23.322 1.718 12.431 6.646 63.695-23.325 93.664z" }))));
};
exports.LeafSimpleIcon = LeafSimpleIcon;
