"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LeafIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const LeafIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M160 35.5l-.4-3.1-3.1-.4c-.7-.1-17.7-2-39.4.5-29 3.4-52.5 13.3-67.9 28.6-19.9 19.9-20 42.1-16.6 57.2 2.6 11.6 7.6 20.7 10.3 25.1l-13.7 13.7 5.7 5.7 13.7-13.7c4.4 2.7 13.5 7.7 25.1 10.3 4.4 1 9.4 1.7 14.7 1.7 13.1 0 28.4-4.1 42.5-18.3 15.4-15.4 25.3-38.8 28.6-67.9 2.5-21.7.6-38.7.5-39.4zm-34.8 101.7c-13.8 13.8-30.5 18.7-49.5 14.5-9.2-2-16.9-5.8-21.3-8.4L69.7 128H112v-8H77.7l36-36H136v-8h-14.3l9.2-9.2-5.7-5.7L92 94.3V68h-8v34.3l-35.3 35.3c-2.5-4.3-6.2-11.8-8.3-21-4.3-19.1.5-35.9 14.4-49.8 29.8-29.8 83.8-28.1 97.5-27.1 1 13.7 2.7 67.6-27.1 97.5z" }))));
};
exports.LeafIcon = LeafIcon;
