"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogoutIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const LogoutIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M45.1 146.9C17 118.8 17 73.2 45.1 45.1s73.8-28.1 101.8 0l5.7-5.7c-31.2-31.2-81.9-31.2-113.1 0s-31.2 81.9 0 113.1C55 168.2 75.5 176 96 176s41-7.8 56.6-23.4l-5.7-5.7c-28.1 28.1-73.7 28.1-101.8 0z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M142.8 126.8L173.7 96l-30.9-30.8-5.6 5.6L158.3 92H104v8h54.3l-21.1 21.2z" }))));
};
exports.LogoutIcon = LogoutIcon;
