"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuestionFrameIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const QuestionFrameIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M90.349 105.932c0-8.121 2.304-12.072 10.535-17.888 6.364-4.39 8.45-7.682 8.45-13.059 0-6.804-5.049-11.413-12.62-11.413-8.341 0-13.389 4.39-15.035 13.279l-8.45-1.098c1.097-6.474 2.963-10.315 7.024-13.937C84.533 57.976 90.349 56 97.043 56c12.948 0 21.728 7.572 21.728 18.766 0 5.157-1.646 9.437-4.829 12.949-1.975 2.085-3.511 3.292-8.45 6.584-5.816 3.84-7.133 6.255-7.133 12.84v4.718h-8.01v-5.925zm10.864 23.045c0 3.84-3.183 7.023-7.024 7.023-3.95 0-7.023-3.073-7.023-7.023 0-3.95 3.073-7.024 7.023-7.024 3.841 0 7.024 3.183 7.024 7.024zM96 176c-44.112 0-80-35.888-80-80s35.888-80 80-80 80 35.888 80 80-35.888 80-80 80zm0-152c-39.701 0-72 32.299-72 72s32.299 72 72 72 72-32.299 72-72-32.299-72-72-72z" }))));
};
exports.QuestionFrameIcon = QuestionFrameIcon;
