"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScaleIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const ScaleIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M157.8 52h2.2v-8h-48.5c-1.8-6.9-8-12-15.5-12s-13.7 5.1-15.5 12H32v8h2.2L16 103.3v.7c0 13.2 10.8 24 24 24s24-10.8 24-24v-.7L45.7 52h34.9C82 57.6 86.4 62 92 63.5V152H52v8h88v-8h-40V63.5c5.6-1.5 10-5.9 11.5-11.5h34.9L128 103.3v.7c0 13.2 10.8 24 24 24s24-10.8 24-24v-.7L157.8 52zM40 59.8L54.3 100H25.7L40 59.8zm0 60.2c-7.4 0-13.7-5.1-15.5-12h31c-1.8 6.9-8.1 12-15.5 12zm56-64c-4.4 0-8-3.6-8-8s3.6-8 8-8 8 3.6 8 8-3.6 8-8 8zm56 3.8l14.3 40.2h-28.7L152 59.8zm0 60.2c-7.4 0-13.7-5.1-15.5-12h31c-1.8 6.9-8.1 12-15.5 12z" }))));
};
exports.ScaleIcon = ScaleIcon;
