"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShareIosIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const ShareIosIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M121.759 53.677L96 29.027l-25.759 24.65-6.804-6.51L96 16.001l32.563 31.164z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M91.138 22.516h9.724v97.664h-9.728z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M144.602 175.998H47.398c-8.264 0-14.582-6.045-14.582-13.953V78.327c0-7.908 6.318-13.954 14.582-13.954h34.023v9.303H47.398c-2.919 0-4.862 1.86-4.862 4.651v83.718c0 2.791 1.943 4.65 4.862 4.65h97.204c2.919 0 4.862-1.859 4.862-4.65V78.327c0-2.791-1.943-4.651-4.862-4.651h-34.023v-9.303h34.023c8.264 0 14.582 6.046 14.582 13.954v83.718c0 7.904-6.318 13.953-14.582 13.953z" }))));
};
exports.ShareIosIcon = ShareIosIcon;
