"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolarYieldIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SolarYieldIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M64.192 92.108a31.964 31.964 0 0163.672 4h8q0-2.024-.2-4a39.956 39.956 0 00-79.512 0q-.196 1.972-.2 4h8a32.176 32.176 0 01.24-4zm17.044-41.832l-7.6-18.34c-1.252.436-2.5.9-3.74 1.412a65.242 65.242 0 00-3.644 1.648l7.6 18.34zm36.7 3.06l7.6-18.336a68.44 68.44 0 00-7.384-3.06l-7.6 18.336zM53.124 74.064l-18.336-7.6a68.468 68.468 0 00-3.06 7.384l18.336 7.6zm87.08 3.688l1.528 3.692 18.34-7.6c-.436-1.252-.9-2.5-1.412-3.74a65.242 65.242 0 00-1.648-3.644l-18.34 7.6zm18.572 26.344H33l-17.024 55.94H175.8zM165 152.044h-27.752l-2.936-18h25.24zm-7.896-25.972h-24.096l-2.284-14h22.148zm-34.476-13.976l2.284 14H99.888v-14zm-30.732 14h-25.02l2.3-14h22.72zm-30.836-14l-2.284 14H34.668l4.252-14zm-28.824 21.976h25.236l-2.936 18h-27.76zm30.4 18l2.936-18h26.324v18zm37.252-18h26.328l2.936 18H99.888z" }),
            react_1.default.createElement(react_native_svg_1.Path, { fill: "none", d: "M0 0h192v192H0z" }))));
};
exports.SolarYieldIcon = SolarYieldIcon;
