"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SparePartsIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const SparePartsIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M16 60h16v95.1l20 5 20-5V60h16V32H16v28zm24-8V40h24v12H40zm0 65.1l24 6v7.8l-24-6v-7.8zm0-8.2v-7.8l24 6v7.8l-24-6zm24-10l-24-6v-7.8l24 6v7.8zm-12 53l-12-3v-15.8l24 6v9.8l-12 3zm12-69l-24-6V60h24v22.9zM80 52h-8V40h8v12zM24 40h8v12h-8V40zm116 13.3l-36 22.5v40.4l36 22.5 36-22.5V75.8l-36-22.5zm28 58.5l-28 17.5-28-17.5V80.2l28-17.5 28 17.5v31.6z" }),
            react_1.default.createElement(react_native_svg_1.Path, { d: "M120 96c0 11 9 20 20 20s20-9 20-20-9-20-20-20-20 9-20 20zm32 0c0 6.6-5.4 12-12 12s-12-5.4-12-12 5.4-12 12-12 12 5.4 12 12z" }))));
};
exports.SparePartsIcon = SparePartsIcon;
