"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnderfloorHeatingControllerIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const UnderfloorHeatingControllerIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 24 24", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M19.752 22H4.248C2.988 22 2 21.224 2 20.22V3.78C2 2.781 2.988 2 4.248 2h15.504C21.012 2 22 2.776 22 3.78v16.44c0 .998-.988 1.78-2.248 1.78zM4.248 3.24c-.606 0-1.008.325-1.008.54v16.44c0 .215.402.54 1.008.54h15.504c.606 0 1.008-.325 1.008-.54V3.78c0-.215-.402-.54-1.008-.54zM12 19.446a3.566 3.566 0 01-2.521-6.09 3.565 3.565 0 016.087 2.523A3.567 3.567 0 0112 19.445zm0-5.894a2.326 2.326 0 10.001 4.652A2.326 2.326 0 0012 13.551zm4.961-2.637H7.04a1.24 1.24 0 01-1.24-1.24v-2.64c0-.685.555-1.24 1.24-1.24h9.922c.685 0 1.24.555 1.24 1.24v2.637a1.24 1.24 0 01-1.24 1.241zM7.04 7.036v2.637h9.922V7.036z" }))));
};
exports.UnderfloorHeatingControllerIcon = UnderfloorHeatingControllerIcon;
