"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WaterDishwashIcon = void 0;
const react_1 = __importDefault(require("react"));
const react_native_svg_1 = require("react-native-svg");
const icon_size_1 = require("../../components/icons/icon-size");
const theme_1 = require("../../theme");
const WaterDishwashIcon = (props) => {
    var _a;
    const { theme } = (0, theme_1.useTheme)();
    const { iconSize = icon_size_1.IconSize.SMALL, iconSizeInPixels, fillColor = theme.textColor, extraThickness = 0, } = props; //@ts-ignore don't worry about unused variable
    const secondToneColor = (_a = props.secondToneColor) !== null && _a !== void 0 ? _a : fillColor;
    const size = iconSizeInPixels ? iconSizeInPixels : iconSize;
    const fill = fillColor;
    return (react_1.default.createElement(react_native_svg_1.Svg, { height: size, viewBox: "0 0 192 192", width: size },
        react_1.default.createElement(react_native_svg_1.G, { fill: fill, stroke: fill, strokeWidth: extraThickness },
            react_1.default.createElement(react_native_svg_1.Path, { d: "M112 72h-8v-.001L32 72v44c0 8.822 7.178 16 16 16h44c8.822 0 16-7.178 16-16v-4h4c8.822 0 16-7.183 16-16.012v-8C128 79.172 120.822 72 112 72zm-12 44c0 4.411-3.589 8-8 8H48c-4.411 0-8-3.589-8-8V80l60-.001V116zm20-20.012c0 4.418-3.589 8.012-8 8.012h-4V80h4c4.411 0 8 3.583 8 7.988v8zm40 67.97H32c-8.822 0-16-7.178-16-16v-8h160v8c0 8.822-7.178 16-16 16zm-136-16c0 4.411 3.589 8 8 8h128c4.411 0 8-3.589 8-8H24zM160.194 28l-4.233 89.284c-.671 8.252-7.676 14.716-15.946 14.716h-30.171a23.998 23.998 0 004.78-8h25.39c4.115 0 7.603-3.204 7.968-7.304L151.806 36H88.209l1.332 27.999h-8.009L79.82 28h80.374z" }))));
};
exports.WaterDishwashIcon = WaterDishwashIcon;
