package com.bosch.tt.privacypolicy.rn.ui;

import com.facebook.react.common.MapBuilder;
import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;
import com.facebook.react.uimanager.annotations.ReactProp;

import java.util.Map;

import javax.annotation.Nullable;

public class TTPrivacyComponentViewManager extends SimpleViewManager<ReactTTPrivacyComponent> {

    private static final String REACT_CLASS = "RNTTPrivacyComponent";

    @Override
    public String getName() {
        return REACT_CLASS;
    }

    @Override
    protected ReactTTPrivacyComponent createViewInstance(ThemedReactContext reactContext) {
        return new ReactTTPrivacyComponent(reactContext);
    }

    @ReactProp(name = "css")
    public void setCSS(final ReactTTPrivacyComponent privacyComponent, final String css) {
        privacyComponent.setCustomCSS(css);
    }

    /**
     * This method maps the "ON_DOCUMENT_LOADED" event to JS "onDocumentLoaded" callback function
     */
    @Nullable
    @Override
    public Map<String, Object> getExportedCustomDirectEventTypeConstants() {
        return MapBuilder.<String, Object>builder()
                .put(TTComponentEvent.ON_DOCUMENT_LOADED.toString(), MapBuilder.of("registrationName", "onDocumentLoaded"))
                .put(TTComponentEvent.ON_SCROLL_ENDED.toString(), MapBuilder.of("registrationName", "onScrollEnded"))
                .build();
    }

}
