"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TTActivityComponent = void 0;
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const types_1 = require("../types");
const internal_native_modules_1 = require("./internal-native-modules");
const RNTTActivityComponent = (0, react_native_1.requireNativeComponent)("RNTTActivityComponent");
class TTActivityComponent extends react_1.default.Component {
    viewHandle = null;
    setRef = (ref) => {
        this.viewHandle = ref ? (0, react_native_1.findNodeHandle)(ref) : null;
    };
    onDocumentLoaded = (event) => {
        this.props.onDocumentLoaded?.(event.nativeEvent);
    };
    onScrollEnded = (_event) => {
        this.props.onScrollEnded?.();
    };
    loadDocument() {
        if (react_native_1.Platform.OS === "android") {
            internal_native_modules_1.RNPrivacyComponent.loadActivityConsent(this.props.selectedCountry, this.viewHandle);
        }
        else {
            internal_native_modules_1.RNTTActivityComponentManager.loadActivityConsent(this.props.selectedCountry, this.viewHandle);
        }
    }
    componentDidUpdate(prevProps) {
        if (this.props.selectedCountry !== prevProps.selectedCountry) {
            this.loadDocument();
        }
    }
    componentDidMount() {
        if (this.props.selectedCountry) {
            this.loadDocument();
        }
    }
    render() {
        return (react_1.default.createElement(react_native_1.View, { style: [this.props.style, { overflow: "hidden" }] },
            react_1.default.createElement(RNTTActivityComponent, { ref: this.setRef, style: { flex: 1 }, css: this.props.css, onDocumentLoaded: this.onDocumentLoaded, onScrollEnded: this.onScrollEnded, activityIndicatorStyle: this.props.activityIndicatorStyle ??
                    types_1.ActivityIndicatorStyle.Gray })));
    }
}
exports.TTActivityComponent = TTActivityComponent;
